function [tt,uu,xx] = pcz_computeU_reachX1_inT(A, B, x0, x1, T)
%%
%  File: pcz_computeU_reachX1_inT.m
%  Directory: 4_gyujtemegy/11_CCS/_1_ccs/ccs_2020/vizeses
%  Author: Peter Polcz (ppolcz@gmail.com) 
%  
%  Created on 2020. September 25. (2020b)
%

N = 100;
t = linspace(0,T,N);

n = size(A,1);

% 0. calculating P(t)'s integrand
Fi = @(t) expm(A*t);
Integrand = zeros(n,n,N);
for i = 1:N
    Integrand(:,:,i) = Fi(t(i))*(B*B')*Fi(t(i))';
end

% 1. calculating P(T)
P = trapz(t,Integrand,3);

% 2. calculating u(t), the input:
u = zeros(1,N);
for i = 1:N
    % see comment on the top of the file
    u(i) = - B' * Fi(T-t(i))' / P * (Fi(t(i))*x0 - x1);    
end

% 3. calculating x(t)
x = zeros(n,N);
for i = 1:N
    Integrand = zeros(n,i);
    for j = 1:i
        Integrand(:,j) = Fi(t(i)-t(j))*B*u(j);
    end
    Integral = trapz(t(1:i),Integrand,2);
    x(:,i) = Fi(t(i))*x0 + Integral;
end

tt = t';
uu = u';
xx = x';

end