%%
%  File: vizeses_main.m
%  Directory: 4_gyujtemegy/11_CCS/_1_ccs/ccs_2020/vizeses
%  Author: Peter Polcz (ppolcz@gmail.com) 
%  
%  Created on 2020. September 24. (2020b)
%

%% Unobservable, uncontrollable

params = [2 1 , 1 1 , 1 2];

x0 = [
    1
    1
    0
    ];

tu = pcz_uk2tu([ 10 0 0 0 10 0 0 ],1);
[tt,xx,A,B,Cn,On] = vizeses_simsolver(params,x0,tu);

pcz_display(A,Cn,On)
Not_Controllable = null(Cn');
Not_Controllable = pcz_find_recdec(Not_Controllable / Not_Controllable(1))

Not_Observable = null(On);
Not_Observable = round(Not_Observable / Not_Observable(1),10);
Not_Observable = pcz_find_recdec(Not_Observable / Not_Observable(1),'tol',1e-4,'maxit',1,'step',1)


%% Observable, controllable

params = [3 1 , 0.1 2 , 0.1 2];

x0 = [
    0
    0
    0
    ];

x1 = [
    10
    0
    0
    ];

CASE = 2;
switch CASE
    case 1

        tu = pcz_uk2tu([ 10 0 0 0 0 0 ],1);
        [tt,xx,A,B,Cn,On] = vizeses_simsolver(params,x0,tu);

    case 2

        [tt,uu,xx] = pcz_computeU_reachX1_inT(A,B,x0,x1,10);
        tu = [tt,uu];
        [tt,xx,A,B,Cn,On] = vizeses_simsolver(params,x0,tu);
        
end
